<?php

namespace PME\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Controller\Menu;
use Teknisa\Libs\Service\Menu as MenuService;


class MenuController {
    
    private $devOpsId;
    private $id;

    public function __construct($devOpsId) {
        $this->devOpsId = $devOpsId;
    }

    public function buildMenuPME(Request $request, Response $response) {
        $menuService = new MenuService();
        $params = $request->getParameters();
            
        $visibleMenus = isset($params['VISIBLE_ELEMENTS']) ? $params['VISIBLE_ELEMENTS'] : null;
        $expiredMenus = isset($params['EXPIRED_ELEMENTS']) ? $params['EXPIRED_ELEMENTS'] : null;
        $menus = $menuService->buildMenu($visibleMenus, $expiredMenus);
        
        $strJsonFileMessage = file_get_contents(__DIR__. "/../../../mobile/dist/assets/json/messages.json");
        $mensagens = json_decode($strJsonFileMessage, true);
        $menusTratados = $this->translateMenu($menus, $mensagens);
        
        $requestMenu = new Menu($menuService);
        $requestMenu->sendResponse($menusTratados, 200);
    }
    
    private function translateMenu($menus, $mensagens) {
        $menusTratados = $menus;
        foreach ($menus as $i => $itens) {
            if (isset($itens['label']) and strpos($itens['label'], '::') <> false) {
                list($chave, $label) = explode('::', $itens['label']);
                $menusTratados[$i]['label'] = $mensagens[$chave][$label];
            }
            
            if (isset($itens['items'])) {
                $menusTratados[$i]['items'] = $this->translateMenu($itens['items'], $mensagens);
            }
        }
        
        return $menusTratados;
    }
    
    /* private function setDevopsId(&$menus) {
        foreach($menus as &$menu) {
            $menu['devOpsId'] = $this->devOpsId;
            $menu['id'] = $this->id;
            $menu['isVisible'] = true;
            $this->id++;
            if(array_key_exists("items", $menu)) $this->setDevopsId($menu['items']);
        }
    } */
    
    /* public function requestToken(Request $request, Response $response) {
        $response->addDataSet(new DataSet('token', ['']));   
    }*/ 
} 