<?php
namespace Indeterminado\Repositories;

class Sistprecoprop extends \Doctrine\ORM\EntityRepository
{
    public static function getQtdFinSistemas($cdPreco)
    {
        $sql = "SELECT MAX(QTFINSISTEMAS) AS MAXSISTEMAS
                  FROM SISTPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP";
        
        $params = array("CDPRECOPROP" => $cdPreco);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function getDescSistemasAte($cdPreco, $qdSistemas)
    {
        $sql = "SELECT VRPERCDESCSIST, QTINISISTEMAS, QTFINSISTEMAS
                  FROM SISTPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP
                   AND :QTDE_SISTEMAS > QTFINSISTEMAS";
        
        $params = array("CDPRECOPROP"   => $cdPreco,
                        "QTDE_SISTEMAS" => $qdSistemas);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function getDescSistemas($cdPreco, $qdSistemas)
    {
        $sql = "SELECT QTINISISTEMAS, QTFINSISTEMAS, VRPERCDESCSIST
                  FROM SISTPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP
                   AND :QTDE_SISTEMAS BETWEEN QTINISISTEMAS AND QTFINSISTEMAS
                 ORDER BY 1";
        
        $params = array("CDPRECOPROP"   => $cdPreco,
                        "QTDE_SISTEMAS" => $qdSistemas);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}